$(() => {
let treeView; let
dataGrid;
const syncTreeViewSelection = function (treeViewInstance, value) {
if (!value) {
treeViewInstance.unselectAll();
} else {
treeViewInstance.selectItem(value);
}
};
const makeAsyncDataSource = function (jsonFile) {
return new DevExpress.data.CustomStore({
loadMode: 'raw',
key: 'ID',
load() {
return $.getJSON(`../../../../data/${jsonFile}`);
},
});
};
$('#treeBox').dxDropDownBox({
value: '1_1',
valueExpr: 'ID',
displayExpr: 'name',
placeholder: 'Select a value...',
showClearButton: true,
inputAttr: { 'aria-label': 'Owner' },
dataSource: makeAsyncDataSource('treeProducts.json'),
contentTemplate(e) {
const $treeView = $('<div>').dxTreeView({
dataSource: e.component.getDataSource(),
dataStructure: 'plain',
keyExpr: 'ID',
parentIdExpr: 'categoryId',
selectionMode: 'single',
displayExpr: 'name',
selectByClick: true,
onContentReady(args) {
const value = e.component.option('value');
syncTreeViewSelection(args.component, value);
},
selectNodesRecursive: false,
onItemSelectionChanged(args) {
const selectedKeys = args.component.getSelectedNodeKeys();
const singleValue = selectedKeys.length > 0 ? selectedKeys[0] : null;
e.component.option('value', singleValue);
},
});
treeView = $treeView.dxTreeView('instance');
e.component.on('valueChanged', (args) => {
syncTreeViewSelection(treeView, args.value);
e.component.close();
});
return $treeView;
},
});
$('#gridBox').dxDropDownBox({
value: 3,
valueExpr: 'ID',
deferRendering: false,
placeholder: 'Select a value...',
inputAttr: { 'aria-label': 'Owner' },
displayExpr(item) {
return item && `${item.CompanyName} <${item.Phone}>`;
},
showClearButton: true,
dataSource: makeAsyncDataSource('customers.json'),
contentTemplate(e) {
const value = e.component.option('value');
const $dataGrid = $('<div>').dxDataGrid({
dataSource: e.component.getDataSource(),
columns: ['CompanyName', 'City', 'Phone'],
hoverStateEnabled: true,
paging: { enabled: true, pageSize: 10 },
filterRow: { visible: true },
scrolling: { mode: 'virtual' },
selection: { mode: 'single' },
selectedRowKeys: [value],
height: '100%',
showBorders: true,
onSelectionChanged(selectedItems) {
const keys = selectedItems.selectedRowKeys;
const hasSelection = keys.length;
e.component.option('value', hasSelection ? keys[0] : null);
},
});
dataGrid = $dataGrid.dxDataGrid('instance');
e.component.on('valueChanged', (args) => {
dataGrid.selectRows(args.value, false);
e.component.close();
});
return $dataGrid;
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="form">
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">DropDownBox with embedded TreeView</div>
<div class="dx-field-value">
<div id="treeBox"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">DropDownBox with embedded DataGrid</div>
<div class="dx-field-value">
<div id="gridBox"></div>
</div>
</div>
</div>
</div>
</div>
</body>
</html>
#form .dx-fieldset {
height: 500px;
}
[{
"ID": 1,
"CompanyName": "Premier Buy",
"Address": "7601 Penn Avenue South",
"City": "Richfield",
"State": "Minnesota",
"Zipcode": 55423,
"Phone": "(612) 291-1000",
"Fax": "(612) 291-2001",
"Website": "http://www.nowebsitepremierbuy.dx"
}, {
"ID": 2,
"CompanyName": "ElectrixMax",
"Address": "263 Shuman Blvd",
"City": "Naperville",
"State": "Illinois",
"Zipcode": 60563,
"Phone": "(630) 438-7800",
"Fax": "(630) 438-7801",
"Website": "http://www.nowebsiteelectrixmax.dx"
}, {
"ID": 3,
"CompanyName": "Video Emporium",
"Address": "1201 Elm Street",
"City": "Dallas",
"State": "Texas",
"Zipcode": 75270,
"Phone": "(214) 854-3000",
"Fax": "(214) 854-3001",
"Website": "http://www.nowebsitevideoemporium.dx"
}, {
"ID": 4,
"CompanyName": "Screen Shop",
"Address": "1000 Lowes Blvd",
"City": "Mooresville",
"State": "North Carolina",
"Zipcode": 28117,
"Phone": "(800) 445-6937",
"Fax": "(800) 445-6938",
"Website": "http://www.nowebsitescreenshop.dx"
}, {
"ID": 5,
"CompanyName": "Braeburn",
"Address": "1 Infinite Loop",
"City": "Cupertino",
"State": "California",
"Zipcode": 95014,
"Phone": "(408) 996-1010",
"Fax": "(408) 996-1012",
"Website": "http://www.nowebsitebraeburn.dx"
}, {
"ID": 6,
"CompanyName": "PriceCo",
"Address": "30 Hunter Lane",
"City": "Camp Hill",
"State": "Pennsylvania",
"Zipcode": 17011,
"Phone": "(717) 761-2633",
"Fax": "(717) 761-2334",
"Website": "http://www.nowebsitepriceco.dx"
}, {
"ID": 7,
"CompanyName": "Ultimate Gadget",
"Address": "1557 Watson Blvd",
"City": "Warner Robbins",
"State": "Georgia",
"Zipcode": 31093,
"Phone": "(995) 623-6785",
"Fax": "(995) 623-6786",
"Website": "http://www.nowebsiteultimategadget.dx"
}, {
"ID": 8,
"CompanyName": "EZ Stop",
"Address": "618 Michillinda Ave.",
"City": "Arcadia",
"State": "California",
"Zipcode": 91007,
"Phone": "(626) 265-8632",
"Fax": "(626) 265-8633",
"Website": "http://www.nowebsiteezstop.dx"
}, {
"ID": 9,
"CompanyName": "Clicker",
"Address": "1100 W. Artesia Blvd.",
"City": "Compton",
"State": "California",
"Zipcode": 90220,
"Phone": "(310) 884-9000",
"Fax": "(310) 884-9001",
"Website": "http://www.nowebsiteclicker.dx"
}, {
"ID": 10,
"CompanyName": "Store of America",
"Address": "2401 Utah Ave. South",
"City": "Seattle",
"State": "Washington",
"Zipcode": 98134,
"Phone": "(206) 447-1575",
"Fax": "(206) 447-1576",
"Website": "http://www.nowebsiteamerica.dx"
}, {
"ID": 11,
"CompanyName": "Zone Toys",
"Address": "1945 S Cienega Boulevard",
"City": "Los Angeles",
"State": "California",
"Zipcode": 90034,
"Phone": "(310) 237-5642",
"Fax": "(310) 237-5643",
"Website": "http://www.nowebsitezonetoys.dx"
}, {
"ID": 12,
"CompanyName": "ACME",
"Address": "2525 E El Segundo Blvd",
"City": "El Segundo",
"State": "California",
"Zipcode": 90245,
"Phone": "(310) 536-0611",
"Fax": "(310) 536-0612",
"Website": "http://www.nowebsiteacme.dx"
}]
[
{
"ID": 1,
"name": "Stores",
"expanded": true
},
{
"ID": "1_1",
"categoryId": 1,
"name": "Super Mart of the West",
"expanded": true
},
{
"ID": "1_1_1",
"categoryId": "1_1",
"name": "Video Players"
},
{
"ID": "1_1_1_1",
"categoryId": "1_1_1",
"name": "HD Video Player",
"price": 220
},
{
"ID": "1_1_1_2",
"categoryId": "1_1_1",
"name": "SuperHD Video Player",
"price": 270
},
{
"ID": "1_1_2",
"categoryId": "1_1",
"name": "Televisions",
"expanded": true
},
{
"ID": "1_1_2_1",
"categoryId": "1_1_2",
"name": "SuperLCD 42",
"price": 1200
},
{
"ID": "1_1_2_2",
"categoryId": "1_1_2",
"name": "SuperLED 42",
"price": 1450
},
{
"ID": "1_1_2_3",
"categoryId": "1_1_2",
"name": "SuperLED 50",
"price": 1600
},
{
"ID": "1_1_2_4",
"categoryId": "1_1_2",
"name": "SuperLCD 55",
"price": 1750
},
{
"ID": "1_1_2_5",
"categoryId": "1_1_2",
"name": "SuperLCD 70",
"price": 4000
},
{
"ID": "1_1_3",
"categoryId": "1_1",
"name": "Monitors"
},
{
"ID": "1_1_3_1",
"categoryId": "1_1_3",
"name": "19\""
},
{
"ID": "1_1_3_1_1",
"categoryId": "1_1_3_1",
"name": "DesktopLCD 19",
"price": 160
},
{
"ID": "1_1_4",
"categoryId": "1_1",
"name": "Projectors"
},
{
"ID": "1_1_4_1",
"categoryId": "1_1_4",
"name": "Projector Plus",
"price": 550
},
{
"ID": "1_1_4_2",
"categoryId": "1_1_4",
"name": "Projector PlusHD",
"price": 750
}
]

import React, { useCallback, useRef, useState } from 'react';
import DropDownBox from 'devextreme-react/drop-down-box';
import type { DropDownBoxTypes } from 'devextreme-react/drop-down-box';
import TreeView from 'devextreme-react/tree-view';
import type { TreeViewTypes, TreeViewRef } from 'devextreme-react/tree-view';
import DataGrid, {
Selection,
Paging,
FilterRow,
Scrolling,
} from 'devextreme-react/data-grid';
import { CustomStore } from 'devextreme-react/common/data';
import 'whatwg-fetch';
const gridColumns: string[] = ['CompanyName', 'City', 'Phone'];
const ownerLabel = { 'aria-label': 'Owner' };
const makeAsyncDataSource = (jsonFile: string): CustomStore =>
new CustomStore({
loadMode: 'raw',
key: 'ID',
load() {
return fetch(`../../../../data/${jsonFile}`).then((response: Response) => response.json());
},
});
const treeDataSource = makeAsyncDataSource('treeProducts.json');
const gridDataSource = makeAsyncDataSource('customers.json');
const gridBoxDisplayExpr = (item: { CompanyName: any; Phone: any }): string =>
item && `${item.CompanyName} <${item.Phone}>`;
function App() {
const treeViewRef = useRef<TreeViewRef>(null);
const [treeBoxValue, setTreeBoxValue] = useState<string>('1_1');
const [gridBoxValue, setGridBoxValue] = useState<number[]>([3]);
const [isGridBoxOpened, setIsGridBoxOpened] = useState<boolean>(false);
const [isTreeBoxOpened, setIsTreeBoxOpened] = useState<boolean>(false);
const treeViewItemSelectionChanged = useCallback(
(e: { component: { getSelectedNodeKeys: () => any } }): void => {
const selectedKeys = e.component.getSelectedNodeKeys();
setTreeBoxValue(selectedKeys.length > 0 ? selectedKeys[0] : null);
},
[],
);
const dataGridOnSelectionChanged = useCallback((e: { selectedRowKeys: any }): void => {
setGridBoxValue(e.selectedRowKeys);
setIsGridBoxOpened(false);
}, []);
const treeViewOnContentReady = useCallback(
(e: TreeViewTypes.ContentReadyEvent): void => {
e.component.selectItem(treeBoxValue);
},
[treeBoxValue],
);
const treeViewRender = useCallback(
() => (
<TreeView
dataSource={treeDataSource}
ref={treeViewRef}
dataStructure="plain"
keyExpr="ID"
parentIdExpr="categoryId"
selectionMode="single"
displayExpr="name"
selectByClick={true}
onContentReady={treeViewOnContentReady}
onItemSelectionChanged={treeViewItemSelectionChanged}
/>
),
[treeViewRef, treeViewOnContentReady, treeViewItemSelectionChanged],
);
const dataGridRender = useCallback(
() => (
<DataGrid
dataSource={gridDataSource}
columns={gridColumns}
hoverStateEnabled={true}
showBorders={true}
selectedRowKeys={gridBoxValue}
onSelectionChanged={dataGridOnSelectionChanged}
height="100%"
>
<Selection mode="single" />
<Scrolling mode="virtual" />
<Paging
enabled={true}
pageSize={10}
/>
<FilterRow visible={true} />
</DataGrid>
),
[gridBoxValue, dataGridOnSelectionChanged],
);
const syncTreeViewSelection = useCallback((e: DropDownBoxTypes.ValueChangedEvent): void => {
setTreeBoxValue(e.value);
if (!treeViewRef.current) return;
if (!e.value) {
treeViewRef.current.instance().unselectAll();
} else {
treeViewRef.current.instance().selectItem(e.value);
}
setIsTreeBoxOpened(false);
}, []);
const syncDataGridSelection = useCallback((e: DropDownBoxTypes.ValueChangedEvent): void => {
setGridBoxValue(e.value);
}, []);
const onGridBoxOpened = useCallback((e: DropDownBoxTypes.OptionChangedEvent): void => {
if (e.name === 'opened') {
setIsGridBoxOpened(e.value);
}
}, []);
const onTreeBoxOpened = useCallback((e: DropDownBoxTypes.OptionChangedEvent): void => {
if (e.name === 'opened') {
setIsTreeBoxOpened(e.value);
}
}, []);
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">DropDownBox with embedded TreeView</div>
<div className="dx-field-value">
<DropDownBox
value={treeBoxValue}
opened={isTreeBoxOpened}
valueExpr="ID"
inputAttr={ownerLabel}
displayExpr="name"
placeholder="Select a value..."
showClearButton={true}
dataSource={treeDataSource}
onValueChanged={syncTreeViewSelection}
onOptionChanged={onTreeBoxOpened}
contentRender={treeViewRender}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">DropDownBox with embedded DataGrid</div>
<div className="dx-field-value">
<DropDownBox
value={gridBoxValue}
opened={isGridBoxOpened}
valueExpr="ID"
deferRendering={false}
inputAttr={ownerLabel}
displayExpr={gridBoxDisplayExpr}
placeholder="Select a value..."
showClearButton={true}
dataSource={gridDataSource}
onValueChanged={syncDataGridSelection}
onOptionChanged={onGridBoxOpened}
contentRender={dataGridRender}
/>
</div>
</div>
</div>
);
}
export default App;
import React, { useCallback, useRef, useState } from 'react';
import DropDownBox from 'devextreme-react/drop-down-box';
import TreeView from 'devextreme-react/tree-view';
import DataGrid, {
Selection, Paging, FilterRow, Scrolling,
} from 'devextreme-react/data-grid';
import { CustomStore } from 'devextreme-react/common/data';
import 'whatwg-fetch';
const gridColumns = ['CompanyName', 'City', 'Phone'];
const ownerLabel = { 'aria-label': 'Owner' };
const makeAsyncDataSource = (jsonFile) =>
new CustomStore({
loadMode: 'raw',
key: 'ID',
load() {
return fetch(`../../../../data/${jsonFile}`).then((response) => response.json());
},
});
const treeDataSource = makeAsyncDataSource('treeProducts.json');
const gridDataSource = makeAsyncDataSource('customers.json');
const gridBoxDisplayExpr = (item) => item && `${item.CompanyName} <${item.Phone}>`;
function App() {
const treeViewRef = useRef(null);
const [treeBoxValue, setTreeBoxValue] = useState('1_1');
const [gridBoxValue, setGridBoxValue] = useState([3]);
const [isGridBoxOpened, setIsGridBoxOpened] = useState(false);
const [isTreeBoxOpened, setIsTreeBoxOpened] = useState(false);
const treeViewItemSelectionChanged = useCallback((e) => {
const selectedKeys = e.component.getSelectedNodeKeys();
setTreeBoxValue(selectedKeys.length > 0 ? selectedKeys[0] : null);
}, []);
const dataGridOnSelectionChanged = useCallback((e) => {
setGridBoxValue(e.selectedRowKeys);
setIsGridBoxOpened(false);
}, []);
const treeViewOnContentReady = useCallback(
(e) => {
e.component.selectItem(treeBoxValue);
},
[treeBoxValue],
);
const treeViewRender = useCallback(
() => (
<TreeView
dataSource={treeDataSource}
ref={treeViewRef}
dataStructure="plain"
keyExpr="ID"
parentIdExpr="categoryId"
selectionMode="single"
displayExpr="name"
selectByClick={true}
onContentReady={treeViewOnContentReady}
onItemSelectionChanged={treeViewItemSelectionChanged}
/>
),
[treeViewRef, treeViewOnContentReady, treeViewItemSelectionChanged],
);
const dataGridRender = useCallback(
() => (
<DataGrid
dataSource={gridDataSource}
columns={gridColumns}
hoverStateEnabled={true}
showBorders={true}
selectedRowKeys={gridBoxValue}
onSelectionChanged={dataGridOnSelectionChanged}
height="100%"
>
<Selection mode="single" />
<Scrolling mode="virtual" />
<Paging
enabled={true}
pageSize={10}
/>
<FilterRow visible={true} />
</DataGrid>
),
[gridBoxValue, dataGridOnSelectionChanged],
);
const syncTreeViewSelection = useCallback((e) => {
setTreeBoxValue(e.value);
if (!treeViewRef.current) return;
if (!e.value) {
treeViewRef.current.instance().unselectAll();
} else {
treeViewRef.current.instance().selectItem(e.value);
}
setIsTreeBoxOpened(false);
}, []);
const syncDataGridSelection = useCallback((e) => {
setGridBoxValue(e.value);
}, []);
const onGridBoxOpened = useCallback((e) => {
if (e.name === 'opened') {
setIsGridBoxOpened(e.value);
}
}, []);
const onTreeBoxOpened = useCallback((e) => {
if (e.name === 'opened') {
setIsTreeBoxOpened(e.value);
}
}, []);
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">DropDownBox with embedded TreeView</div>
<div className="dx-field-value">
<DropDownBox
value={treeBoxValue}
opened={isTreeBoxOpened}
valueExpr="ID"
inputAttr={ownerLabel}
displayExpr="name"
placeholder="Select a value..."
showClearButton={true}
dataSource={treeDataSource}
onValueChanged={syncTreeViewSelection}
onOptionChanged={onTreeBoxOpened}
contentRender={treeViewRender}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">DropDownBox with embedded DataGrid</div>
<div className="dx-field-value">
<DropDownBox
value={gridBoxValue}
opened={isGridBoxOpened}
valueExpr="ID"
deferRendering={false}
inputAttr={ownerLabel}
displayExpr={gridBoxDisplayExpr}
placeholder="Select a value..."
showClearButton={true}
dataSource={gridDataSource}
onValueChanged={syncDataGridSelection}
onOptionChanged={onGridBoxOpened}
contentRender={dataGridRender}
/>
</div>
</div>
</div>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
[{
"ID": 1,
"CompanyName": "Premier Buy",
"Address": "7601 Penn Avenue South",
"City": "Richfield",
"State": "Minnesota",
"Zipcode": 55423,
"Phone": "(612) 291-1000",
"Fax": "(612) 291-2001",
"Website": "http://www.nowebsitepremierbuy.dx"
}, {
"ID": 2,
"CompanyName": "ElectrixMax",
"Address": "263 Shuman Blvd",
"City": "Naperville",
"State": "Illinois",
"Zipcode": 60563,
"Phone": "(630) 438-7800",
"Fax": "(630) 438-7801",
"Website": "http://www.nowebsiteelectrixmax.dx"
}, {
"ID": 3,
"CompanyName": "Video Emporium",
"Address": "1201 Elm Street",
"City": "Dallas",
"State": "Texas",
"Zipcode": 75270,
"Phone": "(214) 854-3000",
"Fax": "(214) 854-3001",
"Website": "http://www.nowebsitevideoemporium.dx"
}, {
"ID": 4,
"CompanyName": "Screen Shop",
"Address": "1000 Lowes Blvd",
"City": "Mooresville",
"State": "North Carolina",
"Zipcode": 28117,
"Phone": "(800) 445-6937",
"Fax": "(800) 445-6938",
"Website": "http://www.nowebsitescreenshop.dx"
}, {
"ID": 5,
"CompanyName": "Braeburn",
"Address": "1 Infinite Loop",
"City": "Cupertino",
"State": "California",
"Zipcode": 95014,
"Phone": "(408) 996-1010",
"Fax": "(408) 996-1012",
"Website": "http://www.nowebsitebraeburn.dx"
}, {
"ID": 6,
"CompanyName": "PriceCo",
"Address": "30 Hunter Lane",
"City": "Camp Hill",
"State": "Pennsylvania",
"Zipcode": 17011,
"Phone": "(717) 761-2633",
"Fax": "(717) 761-2334",
"Website": "http://www.nowebsitepriceco.dx"
}, {
"ID": 7,
"CompanyName": "Ultimate Gadget",
"Address": "1557 Watson Blvd",
"City": "Warner Robbins",
"State": "Georgia",
"Zipcode": 31093,
"Phone": "(995) 623-6785",
"Fax": "(995) 623-6786",
"Website": "http://www.nowebsiteultimategadget.dx"
}, {
"ID": 8,
"CompanyName": "EZ Stop",
"Address": "618 Michillinda Ave.",
"City": "Arcadia",
"State": "California",
"Zipcode": 91007,
"Phone": "(626) 265-8632",
"Fax": "(626) 265-8633",
"Website": "http://www.nowebsiteezstop.dx"
}, {
"ID": 9,
"CompanyName": "Clicker",
"Address": "1100 W. Artesia Blvd.",
"City": "Compton",
"State": "California",
"Zipcode": 90220,
"Phone": "(310) 884-9000",
"Fax": "(310) 884-9001",
"Website": "http://www.nowebsiteclicker.dx"
}, {
"ID": 10,
"CompanyName": "Store of America",
"Address": "2401 Utah Ave. South",
"City": "Seattle",
"State": "Washington",
"Zipcode": 98134,
"Phone": "(206) 447-1575",
"Fax": "(206) 447-1576",
"Website": "http://www.nowebsiteamerica.dx"
}, {
"ID": 11,
"CompanyName": "Zone Toys",
"Address": "1945 S Cienega Boulevard",
"City": "Los Angeles",
"State": "California",
"Zipcode": 90034,
"Phone": "(310) 237-5642",
"Fax": "(310) 237-5643",
"Website": "http://www.nowebsitezonetoys.dx"
}, {
"ID": 12,
"CompanyName": "ACME",
"Address": "2525 E El Segundo Blvd",
"City": "El Segundo",
"State": "California",
"Zipcode": 90245,
"Phone": "(310) 536-0611",
"Fax": "(310) 536-0612",
"Website": "http://www.nowebsiteacme.dx"
}]
[
{
"ID": 1,
"name": "Stores",
"expanded": true
},
{
"ID": "1_1",
"categoryId": 1,
"name": "Super Mart of the West",
"expanded": true
},
{
"ID": "1_1_1",
"categoryId": "1_1",
"name": "Video Players"
},
{
"ID": "1_1_1_1",
"categoryId": "1_1_1",
"name": "HD Video Player",
"price": 220
},
{
"ID": "1_1_1_2",
"categoryId": "1_1_1",
"name": "SuperHD Video Player",
"price": 270
},
{
"ID": "1_1_2",
"categoryId": "1_1",
"name": "Televisions",
"expanded": true
},
{
"ID": "1_1_2_1",
"categoryId": "1_1_2",
"name": "SuperLCD 42",
"price": 1200
},
{
"ID": "1_1_2_2",
"categoryId": "1_1_2",
"name": "SuperLED 42",
"price": 1450
},
{
"ID": "1_1_2_3",
"categoryId": "1_1_2",
"name": "SuperLED 50",
"price": 1600
},
{
"ID": "1_1_2_4",
"categoryId": "1_1_2",
"name": "SuperLCD 55",
"price": 1750
},
{
"ID": "1_1_2_5",
"categoryId": "1_1_2",
"name": "SuperLCD 70",
"price": 4000
},
{
"ID": "1_1_3",
"categoryId": "1_1",
"name": "Monitors"
},
{
"ID": "1_1_3_1",
"categoryId": "1_1_3",
"name": "19\""
},
{
"ID": "1_1_3_1_1",
"categoryId": "1_1_3_1",
"name": "DesktopLCD 19",
"price": 160
},
{
"ID": "1_1_4",
"categoryId": "1_1",
"name": "Projectors"
},
{
"ID": "1_1_4_1",
"categoryId": "1_1_4",
"name": "Projector Plus",
"price": 550
},
{
"ID": "1_1_4_2",
"categoryId": "1_1_4",
"name": "Projector PlusHD",
"price": 750
}
]
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-fieldset {
height: 500px;
}

<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">DropDownBox with embedded TreeView</div>
<div class="dx-field-value">
<dx-drop-down-box
[(value)]="treeBoxValue"
[inputAttr]="{ 'aria-label': 'Owner' }"
[(opened)]="isTreeBoxOpened"
valueExpr="ID"
displayExpr="name"
placeholder="Select a value..."
[showClearButton]="true"
[dataSource]="treeDataSource"
(onValueChanged)="syncTreeViewSelection()"
>
<div *dxTemplate="let data of 'content'">
<dx-tree-view
[dataSource]="treeDataSource"
dataStructure="plain"
keyExpr="ID"
parentIdExpr="categoryId"
selectionMode="single"
displayExpr="name"
[selectByClick]="true"
(onContentReady)="$event.component.selectItem(treeBoxValue)"
(onItemSelectionChanged)="treeView_itemSelectionChanged($event)"
>
</dx-tree-view>
</div>
</dx-drop-down-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">DropDownBox with embedded DataGrid</div>
<div class="dx-field-value">
<dx-drop-down-box
[(value)]="gridBoxValue"
[(opened)]="isGridBoxOpened"
valueExpr="ID"
[deferRendering]="false"
[displayExpr]="gridBox_displayExpr"
placeholder="Select a value..."
[inputAttr]="{ 'aria-label': 'Owner' }"
[showClearButton]="true"
[dataSource]="gridDataSource"
>
<div *dxTemplate="let data of 'content'">
<dx-data-grid
[dataSource]="gridDataSource"
[columns]="gridColumns"
[hoverStateEnabled]="true"
showBorders="true"
[selectedRowKeys]="gridBoxValue"
(onSelectionChanged)="dataGrid_selectionChanged($event)"
height="100%"
>
<dxo-data-grid-selection mode="single"></dxo-data-grid-selection>
<dxo-data-grid-filter-row
[visible]="true"
></dxo-data-grid-filter-row>
<dxo-data-grid-scrolling mode="virtual"></dxo-data-grid-scrolling>
<dxo-data-grid-paging
[enabled]="true"
[pageSize]="10"
></dxo-data-grid-paging>
</dx-data-grid>
</div>
</dx-drop-down-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { enableProdMode, ChangeDetectionStrategy, ChangeDetectorRef, Component, ViewChild, provideZoneChangeDetection } from '@angular/core';
import { HttpClient, provideHttpClient, withFetch } from '@angular/common/http';
import { lastValueFrom } from 'rxjs';
import { CustomStore } from 'devextreme-angular/common/data';
import { DxDataGridModule } from 'devextreme-angular';
import { DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { DxTreeViewModule, DxTreeViewComponent, DxTreeViewTypes } from 'devextreme-angular/ui/tree-view';
import { DxDropDownBoxModule } from 'devextreme-angular/ui/drop-down-box';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
changeDetection: ChangeDetectionStrategy.OnPush,
imports: [
DxTreeViewModule,
DxDropDownBoxModule,
DxDataGridModule,
],
})
export class AppComponent {
@ViewChild(DxTreeViewComponent, { static: false }) treeView: DxTreeViewComponent;
treeDataSource: CustomStore;
gridDataSource: CustomStore;
isTreeBoxOpened = false;
isGridBoxOpened = false;
gridBoxValue = [3];
treeBoxValue: string | string[] = '1_1';
gridColumns = ['CompanyName', 'City', 'Phone'];
constructor(private httpClient: HttpClient, private ref: ChangeDetectorRef) {
this.treeDataSource = this.makeAsyncDataSource(this.httpClient, 'treeProducts.json');
this.gridDataSource = this.makeAsyncDataSource(this.httpClient, 'customers.json');
}
makeAsyncDataSource(http: HttpClient, jsonFile: string) {
return new CustomStore({
loadMode: 'raw',
key: 'ID',
load() {
return lastValueFrom(http.get(`../../../../data/${jsonFile}`));
},
});
}
syncTreeViewSelection() {
if (!this.treeView) return;
if (this.treeBoxValue) {
this.treeView.instance.selectItem(this.treeBoxValue);
} else {
this.treeView.instance.unselectAll();
}
this.isTreeBoxOpened = false;
this.ref.detectChanges();
}
treeView_itemSelectionChanged(e: DxTreeViewTypes.ItemSelectionChangedEvent) {
const selectedKeys = e.component.getSelectedNodeKeys();
this.treeBoxValue = selectedKeys.length > 0 ? selectedKeys[0] : null;
}
dataGrid_selectionChanged(e: DxDataGridTypes.SelectionChangedEvent) {
this.gridBoxValue = e.selectedRowKeys;
this.isGridBoxOpened = false;
this.ref.detectChanges();
}
gridBox_displayExpr = ({ CompanyName, Phone }) => CompanyName && `${CompanyName} <${Phone}>`;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
:host .dx-fieldset {
height: 500px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
[{
"ID": 1,
"CompanyName": "Premier Buy",
"Address": "7601 Penn Avenue South",
"City": "Richfield",
"State": "Minnesota",
"Zipcode": 55423,
"Phone": "(612) 291-1000",
"Fax": "(612) 291-2001",
"Website": "http://www.nowebsitepremierbuy.dx"
}, {
"ID": 2,
"CompanyName": "ElectrixMax",
"Address": "263 Shuman Blvd",
"City": "Naperville",
"State": "Illinois",
"Zipcode": 60563,
"Phone": "(630) 438-7800",
"Fax": "(630) 438-7801",
"Website": "http://www.nowebsiteelectrixmax.dx"
}, {
"ID": 3,
"CompanyName": "Video Emporium",
"Address": "1201 Elm Street",
"City": "Dallas",
"State": "Texas",
"Zipcode": 75270,
"Phone": "(214) 854-3000",
"Fax": "(214) 854-3001",
"Website": "http://www.nowebsitevideoemporium.dx"
}, {
"ID": 4,
"CompanyName": "Screen Shop",
"Address": "1000 Lowes Blvd",
"City": "Mooresville",
"State": "North Carolina",
"Zipcode": 28117,
"Phone": "(800) 445-6937",
"Fax": "(800) 445-6938",
"Website": "http://www.nowebsitescreenshop.dx"
}, {
"ID": 5,
"CompanyName": "Braeburn",
"Address": "1 Infinite Loop",
"City": "Cupertino",
"State": "California",
"Zipcode": 95014,
"Phone": "(408) 996-1010",
"Fax": "(408) 996-1012",
"Website": "http://www.nowebsitebraeburn.dx"
}, {
"ID": 6,
"CompanyName": "PriceCo",
"Address": "30 Hunter Lane",
"City": "Camp Hill",
"State": "Pennsylvania",
"Zipcode": 17011,
"Phone": "(717) 761-2633",
"Fax": "(717) 761-2334",
"Website": "http://www.nowebsitepriceco.dx"
}, {
"ID": 7,
"CompanyName": "Ultimate Gadget",
"Address": "1557 Watson Blvd",
"City": "Warner Robbins",
"State": "Georgia",
"Zipcode": 31093,
"Phone": "(995) 623-6785",
"Fax": "(995) 623-6786",
"Website": "http://www.nowebsiteultimategadget.dx"
}, {
"ID": 8,
"CompanyName": "EZ Stop",
"Address": "618 Michillinda Ave.",
"City": "Arcadia",
"State": "California",
"Zipcode": 91007,
"Phone": "(626) 265-8632",
"Fax": "(626) 265-8633",
"Website": "http://www.nowebsiteezstop.dx"
}, {
"ID": 9,
"CompanyName": "Clicker",
"Address": "1100 W. Artesia Blvd.",
"City": "Compton",
"State": "California",
"Zipcode": 90220,
"Phone": "(310) 884-9000",
"Fax": "(310) 884-9001",
"Website": "http://www.nowebsiteclicker.dx"
}, {
"ID": 10,
"CompanyName": "Store of America",
"Address": "2401 Utah Ave. South",
"City": "Seattle",
"State": "Washington",
"Zipcode": 98134,
"Phone": "(206) 447-1575",
"Fax": "(206) 447-1576",
"Website": "http://www.nowebsiteamerica.dx"
}, {
"ID": 11,
"CompanyName": "Zone Toys",
"Address": "1945 S Cienega Boulevard",
"City": "Los Angeles",
"State": "California",
"Zipcode": 90034,
"Phone": "(310) 237-5642",
"Fax": "(310) 237-5643",
"Website": "http://www.nowebsitezonetoys.dx"
}, {
"ID": 12,
"CompanyName": "ACME",
"Address": "2525 E El Segundo Blvd",
"City": "El Segundo",
"State": "California",
"Zipcode": 90245,
"Phone": "(310) 536-0611",
"Fax": "(310) 536-0612",
"Website": "http://www.nowebsiteacme.dx"
}]
[
{
"ID": 1,
"name": "Stores",
"expanded": true
},
{
"ID": "1_1",
"categoryId": 1,
"name": "Super Mart of the West",
"expanded": true
},
{
"ID": "1_1_1",
"categoryId": "1_1",
"name": "Video Players"
},
{
"ID": "1_1_1_1",
"categoryId": "1_1_1",
"name": "HD Video Player",
"price": 220
},
{
"ID": "1_1_1_2",
"categoryId": "1_1_1",
"name": "SuperHD Video Player",
"price": 270
},
{
"ID": "1_1_2",
"categoryId": "1_1",
"name": "Televisions",
"expanded": true
},
{
"ID": "1_1_2_1",
"categoryId": "1_1_2",
"name": "SuperLCD 42",
"price": 1200
},
{
"ID": "1_1_2_2",
"categoryId": "1_1_2",
"name": "SuperLED 42",
"price": 1450
},
{
"ID": "1_1_2_3",
"categoryId": "1_1_2",
"name": "SuperLED 50",
"price": 1600
},
{
"ID": "1_1_2_4",
"categoryId": "1_1_2",
"name": "SuperLCD 55",
"price": 1750
},
{
"ID": "1_1_2_5",
"categoryId": "1_1_2",
"name": "SuperLCD 70",
"price": 4000
},
{
"ID": "1_1_3",
"categoryId": "1_1",
"name": "Monitors"
},
{
"ID": "1_1_3_1",
"categoryId": "1_1_3",
"name": "19\""
},
{
"ID": "1_1_3_1_1",
"categoryId": "1_1_3_1",
"name": "DesktopLCD 19",
"price": 160
},
{
"ID": "1_1_4",
"categoryId": "1_1",
"name": "Projectors"
},
{
"ID": "1_1_4_1",
"categoryId": "1_1_4",
"name": "Projector Plus",
"price": 550
},
{
"ID": "1_1_4_2",
"categoryId": "1_1_4",
"name": "Projector PlusHD",
"price": 750
}
]